package reichert._03_eingabe;

import processing.core.PApplet;
import processing.core.PImage;

public class AufgabeBildLokalGraustufen extends PApplet {

	private static final long serialVersionUID = 1L;

	int groesse = 20;

	PImage img;
	PImage bearbeitet;

	public void setup() {
		img = loadImage("flickr photos mike 6083251958.jpg");
		bearbeitet = loadImage("flickr photos mike 6083251958.jpg");
		size(img.width, img.height);
	}

	public void draw() {
		if (mousePressed) {
			bearbeitet.loadPixels();
			for (int y = mouseY - groesse; y < mouseY + groesse; y++) {
				for (int x = mouseX - groesse; x < mouseX + groesse; x++) {
					int constrainedX = constrain(x, 0, img.width - 1);
					int constrainedY = constrain(y, 0, img.height - 1);

					float rot = 255 - red(getColor(img, constrainedX, constrainedY));
					float gruen = 255 - green(getColor(img, constrainedX, constrainedY));
					float blau = 255 - blue(getColor(img, constrainedX, constrainedY));

					int grauStufe = (int) (0.2 * rot + 0.59 * gruen + 0.11 * blau);

					setColor(bearbeitet, constrainedX, constrainedY, color(grauStufe, grauStufe, grauStufe));
				}
			}
			bearbeitet.updatePixels();
		}
		image(bearbeitet, 0, 0, bearbeitet.width, bearbeitet.height);
	}

	/**
	 * Liefert die Farbe des Pixels an Koordinate (x,y) in Bild image
	 */
	int getColor(PImage image, int x, int y) {
		return image.pixels[y * image.width + x];
	}

	/**
	 * Setzt die Farbe des Pixels an Koordinate (x,y) in Bild image auf color
	 */
	void setColor(PImage image, int x, int y, int color) {
		image.pixels[y * image.width + x] = color;
	}

}
